ThanksForTheHintDB = ThanksForTheHintDB or {}

function ThanksForTheHint()
    local name = _G[UIDROPDOWNMENU_INIT_MENU].name
    
    if name then
        ThanksForTheHintDB[name] = 1
    end
end

UnitPopupButtons["TFTH"] = {
	text = "Thanks for the hint!",
	dist = 0,
	func =  ThanksForTheHint() 
}

tinsert(UnitPopupMenus["PLAYER"], 	#UnitPopupMenus["PLAYER"] - 1,	"TFTH")
tinsert(UnitPopupMenus["FRIEND"],	#UnitPopupMenus["FRIEND"] - 1,	"TFTH")
tinsert(UnitPopupMenus["PARTY"], 	#UnitPopupMenus["PARTY"] - 1,	"TFTH")

local oldUnitPopup_ShowMenu = _G["UnitPopup_ShowMenu"]

_G["UnitPopup_ShowMenu"] = function(...)

    
    oldUnitPopup_ShowMenu(...)
    for i=1, UIDROPDOWNMENU_MAXBUTTONS do
        local button = _G["DropDownList"..UIDROPDOWNMENU_MENU_LEVEL.."Button"..i];
        if button.value == "TFTH" then
            button.func = ThanksForTheHint
            break;
        end
    end
end 


local OrigAddMessage = ChatFrame1.AddMessage

local function DoIKnowYouChatFrameAddMessage(self, text, ...)
	if type(text) == "string" and text ~= "" then
		
		local _, _, name = text:find("|Hplayer:[^:]+:%d+|h%[(.-)%]|h")
		if name and ThanksForTheHintDB[name] then			
			text = text:gsub("|Hplayer:([^:]+):(%d+)|h%[.-%]|h", "|Hplayer:%1:%2|h["..RED_FONT_COLOR_CODE..name.."|r]|h")
		end
	end

	return OrigAddMessage(self, text, ...)
end
for i=1, NUM_CHAT_WINDOWS do
	local cf = getglobal("ChatFrame"..i)
	if(i~=2) then
		cf.AddMessage = DoIKnowYouChatFrameAddMessage
	end
end